#include <iostream.h>
#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "sort.h"                       //Sortowanie Bbelkowe i szybkie
#include "graf.h"                       //Algorytm Grafowy - macierz ssiedztwa
#include "fib.h"                        //Cig Fibonacciego
#include "sito.h"                       //Sito Eratostenesa - liczby pierwsze


class Rec {
  protected:
	    static int Xmax, Ymax;      //statyczne zmienne okreslajace obszar poruszania sie okna
	    int x1,y1,x2,y2;            //parametry okna (rogi prostokata)
	    int Lenbuf;                 //wielkosc bufora
	    char *buf;                  //wskaznik typu char o nazwie buf
		    virtual int buflen()=0;
		    virtual void wstaw()=0;
		    virtual void usun()=0;
		    void korekta();
  public:
	    Rec(int x1=1,int y1=1,int x2=Xmax,int y2=Ymax):
			x1(x1),y1(y1),x2(x2),y2(y2),Lenbuf(0),buf(NULL)
		{korekta();}
	    //Rec(Rec &);
		    virtual ~Rec() {if(buf) delete buf; buf=NULL;}
		    Rec &operator-();
		    Rec &operator+();
		    void przesun(int, int);
};
int Rec::Xmax=78, Rec::Ymax=20;                           //obszar w jakim moze poruszac sie kazde okno (nawet pulpit)
                                                          //mozna to nazwac "wielkoscia moniotra"
                                                          //inicjujemy zmienna w klasie Rec

class Okno:public Rec {
  protected:
	    char *tyt, *txt;
	    int tlo, nt, poz;
		    virtual int buflen()=0;
		    virtual void wstaw()=0;
		    virtual void usun()=0;
		    virtual void ramka()=0;
		    virtual void zmien(int)=0;
  public:
	    Okno():Rec(1,1,80,25),txt(NULL),tyt(NULL),poz(0),tlo(0)   //tworzymy glowny pulpit
		{                                                     //te okno (pulpit) okresla "wielkosc plpitu"
		 Lenbuf=4000;					      //dajemy jakas liczbe dla wielkosci bufora
		}
	    Okno(char*, char*, int=1, int=1, int=1, int=1);
	    operator int();
};

class Menu: public Okno {
  protected:
		    void wstaw();
		    void zmien(int);
		    void usun();
		    void ramka();
		    int buflen() {return 2*(x2-x1+1)*(y2-y1+1); }    //dlugosc bufora
  public:
	    Menu() {}                                                //bazparametrowy konstruktor (uruchamia bezparametrowy konstruktor klasy okno)
	    Menu(char *t1,char *t2, int x=1, int y=1,int p=1, int c=1):
		Okno(t1, t2, x, y, p, c) { }
	    ~Menu()  { usun();}                                      //dekonstruktor menu uruchania funkcje usun
};



Rec &Rec::operator-()                                   //ukryucie objektu
	 {if(buf) {
		   usun();
		   if(buf) {delete buf; buf=NULL;}
		  }
	  return *this;
	 }

Rec &Rec::operator+()                                   //pokazanie objektu
	 {
	  if(!Lenbuf) Lenbuf=buflen();			//ustalamy wielkosc bufora
	  if(!buf) buf=new char[Lenbuf];		//tworzymy bufor
	  if(buf==NULL) {cout<<"ERROR"<<endl; exit(1);} //objekt nie jest widoaczny
	  if(buf) wstaw();
	  return *this;
	 }

void Rec::przesun(int dx, int dy)                       //funkcja odpowiedzialna za przesuwanie
	 {
	  if(!dx && !dy) return;                                //czy przsuniecie istnieje
	  if(x1+dx<=0) dx=1-x1;                                 //jesli wychodzi poza obszar z lewej to ustaw okno w odleglosci 1 piksla
			else if(x2+dx>Xmax) dx=Xmax-x2;         //jesli wychodzi poza obszar z prawej to ustaw okno w odleglosci 1 piksla
	  if(y1+dy<=0) dy=1-y1;                                 //jesli wychodzi poza obszar z gory to ustaw okno w odleglosci 1 piksla
			else if(y2+dy>Ymax) dy=Ymax-y2;         //jesli wychodzi poza obszar z dolu to ustaw okno w odleglosci 1 piksla
	  if(buf) usun();
	  x1+=dx;                               //przsuwanie LGR - wspolrzedna x
	  y1+=dy;                               //przsuwanie LGR - wspolrzedna y
	  x2+=dx;                               //przsuwanie PDR - wspolrzedna x
	  y2+=dy;                               //przsuwanie PDR - wspolrzedna y
	  if(buf) wstaw();
	 }

void Rec::korekta()                             //funkcja sprawdza czy okno wychodzi poza obszar
	 {
	  int xy;
	  if(x2<x1)                             //sprawdzenie, czy szerokosc nie jest = 0
	    {xy=x1;
	     x1=x2;
	     x2=xy;
	    }
	  if(x1<1)                              //sprawdzenie czy okno wychodzi z lewej strony poza obszar
	     x1=1;                              //jesli tak to cofnij
	  if(x2>Xmax)                           //sprawdzenie czy okno wychodzi z prawej strony poza obszar
	     x2=Xmax;                           //jesli tak to cofnij
	  if(y2<y1)                             //sprawdzenie, czy wysokosc nie jest = 0
	    {
	     xy=y1;
	     y1=y2;
	     y2= xy;
	    }
	  if(y1<1)                              //sprawdzenie czy okno wychodzi z gory poza obszar
	     y1=1;                              //jesli tak to cofnij
	  if(y2>Ymax)                           //sprawdzenie czy okno wychodzi z dolu poza obszar
	     y2=Ymax;                           //jesli tak to cofnij
	 }

Okno::Okno(char *q,char *p,int x,int y,int poz,int tlo):Rec(x, y),tyt(q),txt(p),poz(poz),tlo(tlo) //konstruktor glowny
	 {
	  int m=strlen(tyt);                    //ile wynosi dlugosc nazwy naglowka okna

	  x1=x;
	  y1=y;							//(q-p) - dlugosc pozycji w menu (p - calosc, q - pozycja)
	  for(nt=0; (q=strchr(p,'\n'))!=NULL; p=q+1, nt++)	//tutaj tworzona jest ilosc pozycji w menu (zmienna p)
				if(m < q-p)  m=(int)(q-p);	//powiekszanie miejsca dla naglowka
	  m+=2;                                 		//ile wynosi odleglosc naglowka od rogu okna (dodatkowo, aby poprawic wyglad)
	  x2=x1+m;                             		 	//dodajemy wartosci bo inaczej to okno byloby powiekszone
	  y2=y1+nt+1;                           		//dodajemy wartosci bo inaczej to okno byloby powiekszone
	  korekta();                            		//kontrolnie uruchamiamy korekte
	 }

Okno::operator int()						//definiujemy metode	
	 {
	  int k,c;
	  wstaw();
	  zmien(poz);
	  k=poz;                                //zapamietanie pozycji w menu
	  do
	    {
	     c=getch();                         //c - zmienna "wylapujaca" zdarzenie
	     switch(c)
	      {
	       case 27: return 0;               //klawisz 'ESC' - wywoluje akcje EXIT
	       case 13:                         //klawisz 'ENTER'
	       case 10: poz=k; c=27; break;
/* LEWO */     case 97:  usun();                //klawisz 'A'
			 przesun(-1,0);         //o ile maja by przesowane okna w lewo
			 wstaw();
			 zmien(k);              //wczytanie pozycji menu z wartosci zmiennej
			 break;

/* PRAWO */    case 100: usun();                //klawisz 'D'
			 przesun(1,0);          //o ile maja by przesowane okna w prawo
			 wstaw();
			 zmien(k);              //wczytanie pozycji menu z wartosci zmiennej
			 break;

/* GORA */     case 119: usun();                //klawisz 'W'
			 przesun(0, -1);        //o ile maja by przesowane okna w gore
			 wstaw();
			 zmien(k);              //wczytanie pozycji menu z wartosci zmiennej
			 break;

/* DOL */      case 115: usun();                //klawisz 'S'
			 przesun(0, 1);         //o ile maja by przesowane okna w dol
			 wstaw();
			 zmien(k);              //wczytanie pozycji menu z wartosci zmiennej
			 break;
/* POZYCJA */  case 0:  c=getch();              //strzalki na klawiaturze
			zmien(k);               //wstawienie pozycji w menu
			switch(c)
			{
			 case 72:if(k>1) k--; else k=nt;      //strzalka GORA - jesli na poczatku to przejdz na koniec
				 break;
			 case 80:if(k<nt) k++; else k=1;      //strzalka DOL - jesli na koncu to przejdz na poczatek
				 break;
			}
			zmien(k);                //zmiana pozycji w menu
			break;
	      }
	    } while(c!=27);                     //rob dopuki nie bylo EXIT (klawisz ESC)
	   return poz;
	 }


void Menu::wstaw()						//definiujemy metode
	 {
	  if(!Lenbuf) Lenbuf=buflen();				//ustalamy wielkosc bufora
	  if(!buf) buf=new char[Lenbuf];			//tworzymy bufor
	  gettext(x1, y1, x2, y2, buf);				//pobieramy dane i wrzucamy je do bufora
	  textbackground(tlo);			
	  window(x1, y1, x2, y2);
	  clrscr();
	  if(!txt)
	      return;
	  ramka();
	  gotoxy(1, 2);
	  for(char *p=txt; *p; p++)
			if(putch(*p)=='\n') putch('\r');
	  if(!tyt)
	      return;
	  gotoxy(((x2-x1-3-strlen(tyt))>>1), 1);
	  putch(' ');					//przed tytulem
	  cputs(tyt);					//tytul
	  putch(' ');					//po tytule
	 }

void Menu::zmien(int poz)					//definiujemy metode
	 {
	  int i;
	  int n=(x2-x1-1)<<1;				//tylko srodek bez rogow
	  char *t=new char[n];				//wskaznik tablicowy

	  gettext(x1+1, y1+poz, x2-1, y1+poz, t);
	  for(i=1; i<n; i+=2)
				t[i]^=0x79;
	  puttext(x1+1, y1+poz, x2-1, y1+poz, t);
	  delete t;
	 }

void Menu::usun()                               		//usuwanie okna
	 {
	  if(!buf)
	     return;
	  puttext(x1, y1, x2, y2, buf);
	  delete buf;
	  buf=NULL;
	 }


void Menu::ramka()                              		//fukcja odpowiedzialna za tworzenie ramki do okna
	 {
	  int i;

	  window(x1, y1, x2+1, y2);             //tworzymy ramke
	  gotoxy(1,1);                          //udajemy sie na pozycje... LG rog
	  putch('');                           //wstawiamy lewy gorny rog
	  for(i=x1+1; i<x2; i++) putch('');    //petla odpowiedzialna za gorna pozioma krawedz
	    putch('');                         //wstawiamy prawy goryn rog (bo petla for jest na koncu)
	  for(i=2; i<=y2-y1; i++)               //petla odpowiedzialna za krawedzie pionowe
	   {
	    gotoxy(1, i);                       //udajemy sie na pozycje... LG rog (-1 w dol, bo i=2)
	    putch('');                         //wstawiamy lewa krawedz pionowa
	    gotoxy(x2-x1+1, i);                 //udajemy sie na pozycje... PG rog (-1 w dol, bo i=2)
	    putch('');                         //wstawiamy prawa krawedz pionowa
	   }
	  gotoxy(1, i);                         //udajemy sie na pozycje...
	  putch('');                           //wstawiamy lewy dolny rog
	  for(i=x1+1; i<x2; i++) putch('');    //petla odpowiedzialna za dolna pozioma krawedz
	    putch('');                         //wstawiamy prawy dolny rog
	  window(x1+2, y1, x2, y2);
	 }

void prostokat(int x1,int y1,int x2,int y2,int kolor) 		//funkcja sluzy do tworzenia czarnego tla
	 {
          window(x1,y1,x2,y2);                  //tworzymy okno
	  textbackground(kolor);                //nadajemy oknu tlo
	  clrscr();                             //czyscimy obraz
	 }


void main(void)
{
  int licz;                                     //zmienna odpowiadajaca za wybor w menu
  int x=5, y=4;                                 //domyslne polozenie okna MAIN MENU

  Menu AA, A("MAIN MENU","1.PODMENU I \n" "2.PODMENU II\n" "EXIT (Esc)\n", x, y);  //towrzymy pulpit oraz okno MAIN MENU
  Okno *B1,*B2;
  +AA;                                          //dodajemy pulpit do programu (pulpit powstal z bezparametrowego konstruktora)
                                                //nie jest to wymagane, jednak
                                                //mozemy dodac np. tapete w tle
  do
    {
     switch(A)
      {
       case 1:B1=new Menu("PODMENU I","Funkcja I - Ciag Fibonacciego \nFunkcja II - Sito Eratostenesa\nFunkcja III - Algoryt grafowy\nEXIT (Esc)                             \n", 25, 9);

	      licz=1;
	      do
		 {
		  +A;                                           //po wykonaniu funkcji wczytanie MAIN MENU
		  switch(*B1)
		  {
		    case 1:
			   prostokat(1, 1, 80, 25, BLACK);      //tworzymy czarne tlo w celu przejrzystosci

			   Fib();

			   break;
		    case 2:
			   prostokat(1, 1, 80, 25, BLACK);      //tworzymy czarne tlo w celu przejrzystosci

                           Sito();

			   break;
		    case 3:
			   prostokat(1, 1, 80, 25, BLACK);      //tworzymy czarne tlo w celu przejrzystosci

			   Graf();

			   break;
		    case 4:
		           default:licz=0;  
			   break;
		   }
		  if(licz) getch();				//0, czyli FALSE
		  prostokat(1, 1, 80, 25, BLACK);               //tworzymy czarne tlo w celu przejrzystosci
		 } while(licz);
	      delete B1;                                        //usuwamy okno po wyjsciu
	      break;

       case 2:
	      B2=new Menu("PODMENU II","Funkcja I - Babelkowe\nFunkcja II - Szybkie\nFunkcja III\nEXIT (Esc)             \n", 25, 9);
	      licz=1;
	      do
		 {
		  +A;                                           //po wykonaniu funkcji wczytanie MAIN MENU
		  switch(*B2)
		   {
		    case 1:
			   prostokat(1, 1, 80, 25, BLACK);      //tworzymy czarne tlo w celu przejrzystosci
			   gotoxy(40, 12);

			   Babelki();

			   break;
		    case 2:
			   prostokat(1, 1, 80, 25, BLACK);      //tworzymy czarne tlo w celu przejrzystosci
			   gotoxy(40, 12);

                           Szybki();

			   break;

		    case 3:
			   default:licz=0;			//0, czyli FALSE
			   break;
		   }
		  if(licz) getch();
		  prostokat(1, 1, 80, 25, BLACK);               //tworzymy czarne tlo w celu przejrzystosci
		 } while(licz);
	      delete B2;                                        //usuwamy okno po wyjsciu (uruchamiamy dekonstruktor MENU
	      break;



       case 3:
       default:B1=NULL;						//nie usuwamy tylko "czyscimy"
	       B2=NULL;						//nie usuwamy tylko "czyscimy"
	       break;
      }
    } while(B1 && B2);						//while sprawdze czy istnieje

 prostokat(0,0,80,25,BLACK);
 }